package ovh.herisson.Clyde.EndPoints;


import org.springframework.http.HttpStatus;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import ovh.herisson.Clyde.Responses.UnauthorizedResponse;
import ovh.herisson.Clyde.Services.TokenService;
import ovh.herisson.Clyde.Services.UserService;
import ovh.herisson.Clyde.Tables.User;


@RestController
@CrossOrigin(origins = "http://localhost:5173")
public class UserController {

    private final UserService userService;

    private final TokenService tokenService;
    public UserController(UserService userService, TokenService tokenService){
        this.userService = userService;
        this.tokenService = tokenService; // todo find a way to be clearer

        tokenService.postMockToken(userService.postMockUsers());// todo find a better place to put that
    }

    @GetMapping("/user")
    public ResponseEntity<User> getUsers(@RequestHeader("Authorization") String token){

        User user = tokenService.getUserFromToken(token);

        if (user == null) {
            return new UnauthorizedResponse<User>(null);
        }
        return new ResponseEntity<User>(user, HttpStatus.OK);
    }

    @PostMapping("/user")
    public ResponseEntity<String> postUser(@RequestBody User user){
        userService.save(user);
        return new ResponseEntity<String>(String.format("Account created with ID:%s",user.getRegNo()),HttpStatus.CREATED);
    }

    @GetMapping("/users")
    public Iterable<User> getAllUsers(){//TODO ne l'accepter que si c'est le secrétariat
        return userService.getAll();
    }


}

